; Program za 64-bitno dijeljenje metodom oduzimanja, ver. 1
; - Uvjet programa: djeljenik i djelitelj su bez predznaka

	AREA div_64_v1, CODE, READWRITE
	
ADDR EQU 0x8100			; adresa na kojoj se nalaze podatci
	
	ENTRY
	
	MOV R4, #ADDR   	; postavlja registar R4 adresu podataka

	LDMIA R4!, {R5,R6,R7,R8}; ucitavanje oba operanda
								; korsitenjem Load Multiple naredbe
								; (djeljenik=R6,R5, djelitelj=R8,R7)
	MOV R9, #0			; reset rezultata niza rijec
	MOV R10, #0			; reset rezultata visa rijec	
	
DIV
	CMP R8, R6			; ako je djelitelj_H > trenutacnog
								; ostatka_H
	BHI KRAJ				; zapisi rezultate i zavrsi program
	CMPEQ R7, R5		; ako su isti usporedi djelitelj_L 
								; i trenutacni ostatak_L
	BHI KRAJ				; ako je djeljitelj_L veci, zapisi
								; rezultate i zavrsi program	
	SUBS R5, R5, R7	; inace oduzmi djelitelj od trenutacnog
								; ostatka
	SBC R6, R6, R8
	ADDS R9, R9, #1	; i povecaj rezultat za 1
	ADC R10, R10, #0	
	B DIV					; ponavljaj petlju
KRAJ
	STMIA R4!, {R5,R6,R9,R10}	; spremanje rezultata
								; prvo se sprema ostatak (R5,R6) a zatim
								; rezultat (R9,R10)

	MOV R0, #0x18		; angel_SWIreason_ReportException
	LDR R1, =0x20026	; ADP_Stopped_ApplicationExit
	SWI 0x123456		; ARM semihosting SWI
		
	END

